import java.io.*;
import java.sql.*;

class PerformanceDegradation
{
  static String remove_table = "drop sequence degradation_id_seq; drop table degradation;";

  static String create_table = "create table degradation ( id serial primary key, x integer,y integer );";

  static int turn = 0;

  public static void main(String[] args)
  {
    Connection con = null;
    PreparedStatement st = null;
      
    try
    {
      Driver driver = (Driver)Class.forName("org.postgresql.Driver").newInstance();
      con = DriverManager.getConnection("jdbc:postgresql:test", "wardays_app", null);

      try
      {
        st = con.prepareStatement(remove_table);
//        st.execute();
        st.close();
      }
      catch( SQLException ex )
      {
        System.err.println("ignored:"+ex);
      }

      st = con.prepareStatement(create_table);
//      st.execute();
      st.close();

      st = con.prepareStatement("begin transaction");
//      st.execute();
      st.close();
      st = con.prepareStatement("insert into degradation(x,y) values(?,?)");
      for( int i=0; i<3000; ++i )
      {
        st.setInt(1,i%123);
        st.setInt(2,i%71);
//        st.executeUpdate();
      }
      st.close();
      st = con.prepareStatement("commit");
//      st.execute();
      st.close();

      while(true)
      {
        long start = System.currentTimeMillis();

        st = con.prepareStatement("begin transaction");
        st.execute();
        st.close();

        st = con.prepareStatement("update degradation set x=?,y=? where id=?");
        for( int i=0; i<3000; ++i )
        {
          st.setInt(1,i%123);
          st.setInt(2,i%71);
          st.setInt(3,i);
          st.executeUpdate();
        }
        st.close();

        // commit transaction
        st = con.prepareStatement("commit");
        st.execute();
        st.close();

        con.commit();

        long end = System.currentTimeMillis();
        System.out.println("turn:"+turn+" elapsed time:"+(float)(end-start)/1000.0);

        turn++;
      }
    }
    catch( Exception ex )
    {
      System.err.println(ex);
    }
    finally
    {
      try
      {
        con.close();
      }
      catch( SQLException ex )
      {
      }
    }
  }
}

